
<img src="https://d9hhrg4mnvzow.cloudfront.net/www.vuestorefront.io/280b19d0-logo-vs_0by02c0by02c000000.jpg"></img>

# Vue Storefront - Headless PWA for any eCommerce

<a href="https://travis-ci.org/DivanteLtd/vue-storefront"><img src="https://travis-ci.org/DivanteLtd/vue-storefront.svg?branch=master" alt="build:passed"></a>
![version](https://img.shields.io/badge/node-v10.x-blue.svg)
<a href="https://github.com/DivanteLtd/vue-storefront"><img src="https://img.shields.io/badge/stable%20branch-master-blue.svg" alt="Branch stable"></a>
<a href="https://github.com/DivanteLtd/vue-storefront/tree/develop"><img src="https://img.shields.io/badge/dev%20branch-develop-blue.svg" alt="Branch Develop"></a>
<a href="https://slack.vuestorefront.io">![Branch Develop](https://img.shields.io/badge/community%20chat-slack-FF1493.svg)</a>

Vue Storefront is a standalone PWA storefront for your eCommerce, possible to connect with any eCommerce backends, for example:
- <a href="https://www.vuestorefront.io/pwa-for-magento?utm_source=github.com&utm_medium=referral&utm_campaign=readme">Magento</a>  
- <a href="https://www.vuestorefront.io/shopware?utm_source=github.com&utm_medium=referral&utm_campaign=readme">Shopware</a>
- <a href="https://www.vuestorefront.io/commercetools?utm_source=github.com&utm_medium=referral&utm_campaign=readme">commercetools</a>
- <a href="https://www.vuestorefront.io/about-you-cloud?utm_source=github.com&utm_medium=referral&utm_campaign=readme">About You Cloud</a>
- <a href="https://github.com/DivanteLtd/coreshop-vsbridge">Pimcore/CoreShop</a>
-  [BigCommerce](https://github.com/DivanteLtd/bigcommerce2vuestorefront) 


Vue Storefront is and always will be **open source** (MIT Licence). Anyone can use and support the project, we want it to be a tool for the improvement of the shopping experience.
The project is in the **production ready** phase.

## Links

-   📘  Documentation:  [docs.vuestorefront.io](https://docs.vuestorefront.io)
-   👥  Slack Community:  [slack.vuestorefront.io](https://slack.vuestorefront.io/)
-   🐦  Twitter:  [@VueStorefront](https://twitter.com/VueStorefront)
-   💬  Forum:  [forum.vuestorefront.io](https://forum.vuestorefront.io/)
-   🌟  [Live Projects List](https://www.vuestorefront.io/live-projects/?utm_source=github.com&utm_medium=referral&utm_campaign=readme)

## How to start?

Which Vue Storefront should I choose for my next project?  

 - If you’re on **Magento 1 or Magento 2** choose Vue Storefront 1.x
   with vsf-capybara theme,  [Install it using CLI](https://docs.vuestorefront.io/guide/cookbook/setup.html)
   
  -  If you’re on **commercetools / About You Cloud** choose Vue Storefront Next clone it from [`next`](https://github.com/DivanteLtd/vue-storefront/tree/next) 
   
  -  If you’re on **Shopware 6** go to  [`shopware-pwa`](https://github.com/DivanteLtd/shopware-pwa)   sub-project and use the Shopware PWA powered by Vue Storefront

Check our Rodmap -> link do  [https://github.com/DivanteLtd/vue-storefront#roadmap](https://github.com/DivanteLtd/vue-storefront#roadmap)

## About Vue Storefront Next

We're developing a next version of Vue Storefront on the  [`next`  branch](https://github.com/DivanteLtd/vue-storefront/tree/next).

We're building the following integrations within Next architecture:

-   Shopware 6 (developer preview)
-   Commercetools (developer preview)
-   AboutYou Cloud
-   Shopify
-   Salesforce Commerce Cloud

You can learn more about Vue Storefront Next from the README on the  `next`  branch and  [this](https://www.youtube.com/watch?v=0e2wyhR0ZyQ&t=3s)  video

## About Vue Storefront 1.x

**Important note to developers:** From 1.0RC we started using [develop](https://github.com/DivanteLtd/vue-storefront/tree/develop) branch for nightly builds (contains all new features) and [master](https://github.com/DivanteLtd/vue-storefront/tree/master) branch for stable. Please make sure you're working on right branch. Please take a look at [Contributing guidelines](https://github.com/DivanteLtd/vue-storefront/blob/master/CONTRIBUTING.md).

If you're new and need some guidance feel free to visit out [forum](https://forum.vuestorefront.io/) or reach anyone from the core team on our [Slack](https://slack.vuestorefront.io/):
- `@Filip Rakowski` (frontend and best practices)
- `@pkarw` (integrations and backend)
- `@ptomczyk` (frontend and best practices)
- `@lukeromanowicz` (testing, magento, backend)
- `@degi` Degi Kwag (docs)

Want to invest some time in building the future of eCommerce? we are looking for core team members willing to help us make VS even more awesome. Interested - contact `@Filip Rakowski` on slack

**We are looking for Contributors and Designer willing to help us in the solution development.**

**Read [contribution rules](https://github.com/DivanteLtd/vue-storefront/blob/master/CONTRIBUTING.md) before making any pull request. Pull request that doesn't meet these requirements will not be merged**

PS: Check [Storefront UI](https://github.com/DivanteLtd/storefront-ui/) - our UI library for eCommerce.


## See it in action

<table>
  <tbody>
    <tr>
      <td align="center" valign="middle">
        <a href="https://demo.storefrontcloud.io">
          <img
            src="https://divante.co/open-graph/vuestorefront/GitHub-Readme-Try-Demo.png"
            alt="B2C Theme demo" />
        </a>
      </td>
      <td align="left" valign="top">
        Try out our open demo and if you like it <strong>first give us some star on Github ★</strong> and then contact us on <a href="https://slack.vuestorefront.io">Slack</a> or via contributors@vuestorefront.io. <br /><br /> This demo site is connected to <a href="http://demo-magento2.vuestorefront.io">Magento 2.2</a> with shopping carts and users synchronization so You can make an order (which unfortunately won't be shipped ;P). <br /><br />If You like to see Magento 1 integration demo please <a href="https://vuestorefront.io">do contact us</a>.
      </td>
    </tr>
  </tbody>
</table>

## 🆕 Capybara Theme

Starting new project on Vue Storefront? Try out the new <a href="https://github.com/DivanteLtd/vsf-capybara">Capybara Theme</a>. Based on <a href="https://storefrontui.io">StorefrontUI Design System</a>


<table>
  <tbody>
    <tr>
      <td align="center" valign="middle">
        <a href="https://capybara.storefrontcloud.io/">
          <img width="290" 
            src="http://i3.ytimg.com/vi/x2_w-ZBOfqE/maxresdefault.jpg"
            alt="B2C Theme demo" />
        </a>
      </td>
      <td align="left" valign="top">
        Try out our open demo and if you like it <strong> first give us some star on Github ★</strong> and then contact us on <a href="https://slack.vuestorefront.io">Vue Storefront Official Slack</a> or via contributors@vuestorefront.io. <br /><br /> This demo site is connected to Magento2. <br />
      </td>
    </tr>
  </tbody>
</table>

## Be up to date with the news

We're trying to be very open regarding our development plans, news, roadmap and in general: sharing a lot. Please do bookmark our [Official blog](https://blog.vuestorefront.io/) to be always up to date!

## Foundations | Vue Storefront 1.x

[![See how it works!](https://blog.vuestorefront.io/wp-content/uploads/2020/03/Foundations-_-Vue-Storefront.png)](https://www.youtube.com/watch?v=o10oinxCYfY&list=PLIDwzUVxSXjN9pK1NzBTcirV3-K0OCay0)

## How to install Vue Storefront on Windows?

[![Demo and the architecture of Vue Storefront](https://blog.vuestorefront.io/wp-content/uploads/2020/03/How-to-install-Vue-Storefront-on-Windows_.png)](https://www.youtube.com/watch?v=zL_T3WzVLG0&list=PLIDwzUVxSXjN9pK1NzBTcirV3-K0OCay0&index=2)

- [Read on how to integrate it with Magento2](https://docs.vuestorefront.io/guide/installation/magento.html#using-native-magento-2-module), [Read how to create Vue Storefront theme](https://docs.vuestorefront.io/guide/core-themes/themes.html),
- [Read the interviews with authors of first production deployments](http://blog.vuestorefront.io/vsf-on-production-interview-with-gogetgold-com/)

## Is it production ready?

Yes! There are more than **140 implementations** happening right now and many live shops (check [awesome live projects on Vue Storefront](https://www.vuestorefront.io/live-projects/?utm_source=github.com&utm_medium=referral&utm_campaign=readme)).

## Browser Compatibility

* last 2 Chrome versions
* last 2 Firefox versions
* last 2 Edge versions
* modern browsers

For an up-to-date list of supported browsers please see "browserslist" in package.json

## Join the community on Slack

If you have any questions or ideas feel free to join our slack via invitation link: [https://slack.vuestorefront.io/](https://slack.vuestorefront.io/)

## Roadmap

[Here](https://github.com/DivanteLtd/vue-storefront/milestones) you can find the accepted roadmap for current milestone and what you can expect with next release.

#### Roadmap planning
[Here](https://github.com/DivanteLtd/vue-storefront/projects/3) you can vote for feature requests and see which ones were accepted. The most upvoted ones will be added to the next milestones. You can also join the slack channel `#roadmap-planning` where we discuss the next milestones.

The process of adding new features to the roadmap looks like this:
1. You create an issue and label it as `feature request`.
2. One of VS Core team verifies the feature request and if the explanation is clear, it is added to the `Roadmap` project so it's visible in the board.
3. Now people can vote for this feature to be added into next milestone with `thumb up` emoji.
4. Feature requests with the biggest popularity will be added into next milestones.

We are planning 1-2 milestones ahead. Our milestones are based on requirements from community, partners and production implementations.

Please note that bugfixes are treated separately and in most cases added to the milestones immediately.



[Check the feature list of 1.0](https://docs.vuestorefront.io/guide/basics/feature-list.html).

If youd like to take part in roadmap planning feel free to join #roadmap-planning channel on our slack

## Documentation + table of contents

The documentation is always THE HARDEST PART of each open source project! But we're trying hard.

**Please find out what we've already managed to prepare:** [available on Github Pages](https://docs.vuestorefront.io/). Please note that new docs are still Work In Progress and will be successfully updated. You can find them also under the `docs` folder.

You can find some tutorials and explanations on our [YouTube channel](https://www.youtube.com/vuestorefront)

### Installation

- [Starter pack for install](https://docs.vuestorefront.io/guide/cookbook/setup.html)
- [Installing on Linux/MacOS](https://docs.vuestorefront.io/guide/installation/linux-mac.html)
- [Installing on Windows](https://docs.vuestorefront.io/guide/installation/windows.html)
- [How to install and integrate with Magento2](https://docs.vuestorefront.io/guide/installation/magento.html)
- [Production setup](https://docs.vuestorefront.io/guide/installation/production-setup.html)

### Cookbooks

- [Ch1. Data Imports](https://docs.vuestorefront.io/guide/cookbook/data-import.html)
- [Ch2. Elasticsearch in the VSF context](https://docs.vuestorefront.io/guide/cookbook/elastic.html)
- [Ch3. Starter pack for new comers (Install)](https://docs.vuestorefront.io/guide/cookbook/setup.html)
- [Ch5. Building a Module from scratch](https://docs.vuestorefront.io/guide/cookbook/module.html)
- [Ch6. Theming in depth](https://docs.vuestorefront.io/guide/cookbook/theme.html)
- [Chef's secret note: Hardcore training for serious business](https://docs.vuestorefront.io/guide/cookbook/checklist.html)

## Awesome projects on Vue Storefront

Check [**Vue Storefront Live Projects**](https://www.vuestorefront.io/live-projects/?utm_source=github.com&utm_medium=referral&utm_campaign=readme)

![Vue Storefront Live Projects](https://uploads-ssl.webflow.com/5e7cf661c23ac9df156d9c3d/5eff4e5149334a10bb672790_GitHub_Live%20Projects.png)



## The business challenges

Vue Storefront was created to solve a set of key business challenges from the world of the shopping experience. Our goal for the application is to provide the solution with:

- The ultrafast front-end for the store - with the PWA approach we can now render the catalog of products within milliseconds;
- The endurance for traffic overloads on the store;
- The off-line shopping capabilities;
- The smooth shopping experience close to the user experience from the native mobile applications;
- The all-in-one front-end for desktop and mobile screens with no necessity for maintaining 3 or more applications for different touchpoints (web browser, Android, iOS etc.).
- Rapid development without architecture limitations.

## The technology

Vue Storefront was built as an all-in-one front-end for eCommerce. For providing the best performance we decided to use Vue.js as a front-end library, Node.js + Express (and maybe GraphQL support) as a server-API, Elastic Search as a database of products and full PWA/off-line support.
Here you can read more about the proof of concept for [Vue Storefront connected with Magento2](https://www.linkedin.com/pulse/magento2-nosql-database-pwa-support-piotr-karwatka).

Besides a big improvement for the shopping experience, we also want to create a great code base for every developer who needs to work on a front-end application for the eCommerce.

## The headless architecture

![Vue Storefront - Headless Architecture](https://uploads-ssl.webflow.com/5e7cf661c23ac9df156d9c3d/5eff4a2497a1546ca057dcca_github_headless_architecture.png)

## Design

Vue Storefront supports by default **two different themes:**
1. **[Capybara Theme based on Storefront UI](https://github.com/DivanteLtd/vsf-capybara)**

<img alt="Vue Storefront - Capybara Theme" src="https://uploads-ssl.webflow.com/5e7cf661c23ac9df156d9c3d/5eff49534dba189aafa21e55_Github_Capybara_Theme.jpg">

 
2. **[Classic/Default ](https://github.com/DivanteLtd/vsf-default)**

The application is prepared to be fully customized in design through the theming system.
With the current version we work on raw, basic template of typical eCommerce for a fashion industry. In the project we used [Material Icons](https://github.com/google/material-design-icons).

<img width="880" alt="Vue Storefront - Annimations in sidebar menu" src="https://user-images.githubusercontent.com/18116406/33559404-ed674bcc-d90c-11e7-864a-91e42d1c92cd.gif">

Here you can read more about the process of [designing PWA for eCommerce](https://www.linkedin.com/pulse/designing-pwa-ecommerce-karl-bzik/).

The design is available in open source in the Figma file format under the URL https://www.figma.com/file/VKyqbHFI55TKIKcQlFLiVpVF/Vue-Storefront-Open-Source.

## Concerns when hosting
When hosting NodeJS applications there are some differences compared to, for example, hosting PHP or Java applications.
Server Side Rendering via NodeJS can have memory leaks because of suboptimal code. Although core code is optimized, project specific features or misaligned hosting configuration can introduce this. More on how to avoid these for VueJS can be ready in [this article](https://vuejs.org/v2/cookbook/avoiding-memory-leaks.html). We also recommend reading about [VueJS best practices](https://blog.usejournal.com/vue-js-best-practices-c5da8d7af48d).

 On the server we advice to run [PM2](http://pm2.keymetrics.io/) which offers features to keep your NodeJS application stable. When hosting on Kubernetes the checks and memory limits can be leveraged to kill unhealthy containers.
More on hosting can be found in [the documentation](https://docs.vuestorefront.io/guide/installation/production-setup.html#production-setup-bare-vps).

## Other platforms
Vue Storefront is platform agnostic which means it can be connected to virtually any CMS. Please take a look at [Pimcore bridge](https://github.com/DivanteLtd/coreshop-vsbridge) to give you an idea of how other platforms can be connected. Any support for integrating Prestashop, Shopify ... - much appreciated.

## Contributing

If you like the idea behind Vue Storefront and want to become a contributor - do not hesitate and check our [list of the active issues](https://github.com/DivanteLtd/vue-storefront/issues) or contact us directly via contributors@vuestorefront.io.

If you have discovered a 🐜 or have a feature suggestion, feel free to create an issue on Github.

## Workshops

If you like our project and would like to learn more on how to create Progressive Web Apps you can ask us for a dedicated workshop at your office! Conducted by Vue Storefront core contributors! All the profits are used for supporting Vue Storefront development. [Learn more]([https://divante.com/products/vue-storefront](https://divante.com/products/vue-storefront))

## Support us!

**Vue Storefront is and always will be Open Source, released under MIT Licence.**

Most of the core team members, VS contributors and contributors in the ecosystem do this open source work in their free time. If you use Vue Storefront for a serious task, and you'd like us to invest more time on it, you can donate the project! You can support us in various ways:

- **Contribute** - this is how the Core Team is supporting the project!
- **Evangelize** - tweet about us, take some speaking slot at tech conference etc.
- **Sponsor** - if you're doing serious business on VS maybe You would like to donate the project and put your logo in here?

This is how we will use the donations:

- Allow the core team to work on VS
- Thank contributors if they invested a large amount of time in contributing
- Support projects in the ecosystem that are of great value for users
- Infrastructure cost
- Fees for money handling

**If you would like to support us please just let us know: contributors@vuestorefront.io**

## Partners

Vue Storefront is a Community effort brought to You by our great Core Team and supported by the following companies. 

[**See Vue Storefront partners directory**](https://www.vuestorefront.io/partner-agencies?utm_source=github.com&utm_medium=referral&utm_campaign=readme)

![enter image description here](https://uploads-ssl.webflow.com/5e7cf661c23ac9df156d9c3d/5eff4e56262af66301c950e4_github_partner_agencies.png)


Partners are encouraged to support the project in various ways - mostly by contributing the source code, marketing activities, evangelizing and of course - implementing the production projects. We do support our partners by dedicated contact channels, workshops and by sharing the leads from merchants interested in implementations.

If you like to become our Partner just let us know via contributors@vuestorefront.io.

## The screenshots

<img width="880" alt="Vue Storefront - Annimations in the sidebar cart" src="https://user-images.githubusercontent.com/18116406/33559769-2840fb70-d90e-11e7-8f2b-298f35d1b412.gif">



## The license

Vue Storefront source code is completely free and released under the [MIT License](https://github.com/DivanteLtd/vue-storefront/blob/master/LICENSE).

[![analytics](http://www.google-analytics.com/collect?v=1&t=pageview&_s=1&dl=https%3A%2F%2Fgithub.com%2FDivanteLtd%2Fvue-storefront&_u=MAC~&cid=1757014354.1393964045&tid=UA-108235765-10)]()
